MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0025768Open CASCADE[OCCT] OCCT:Visualizationpublic2015-01-30 12:252015-05-14 15:32
Reporterkgv 
Assigned Tobugmaster 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.8.0 
Target Version[OCCT] 6.9.0Fixed in Version[OCCT] 6.9.0 
Summary0025768: Visualization, Graphic3d_Structure - do not use invalid bounding boxes of empty groups
DescriptionWithin current implementation of Graphic3d_Structure::minMaxCoord(), uninitialized state of bounding box of empty group is forcibly ignored within theToIgnoreInfiniteFlag flag:
Graphic3d_BndBox4f Graphic3d_Structure::minMaxCoord (const Standard_Boolean theToIgnoreInfiniteFlag) 
const
{
  Graphic3d_BndBox4f aBnd;
  for (Graphic3d_SequenceOfGroup::Iterator aGroupIter (myCStructure->Groups()); aGroupIter.More(); 
aGroupIter.Next())
  {
    if (!theToIgnoreInfiniteFlag)
    {
      aBnd.Combine (aGroupIter.Value()->BoundingBox());
    }
    else
    {
      Graphic3d_BndBox4f aValidBnd (aGroupIter.Value()->BoundingBox().CornerMin(),
                                    aGroupIter.Value()->BoundingBox().CornerMax());
      aBnd.Combine (aValidBnd);
    }
  }
  return aBnd;
}


This leads to broken bounding box of the structure (bounding box always includes (0, 0, 0)).
For the moment, this always happens for wireframe structures, since their builder Prs3d_WFShape creates dummy empty groups.
Steps To Reproduce
pload MODELING VISUALIZATION
box b 100 0 0 2 1 1
vinit View1
vclear
vaxo
vsetdispmode 0
vdisplay b
vfit
vzoom 0.1
vbounding b
TagsNo tags attached.
Test case numberbugs vis bug25768
Attached Filespng file icon bnd_KO.png (1,506 bytes) 2015-01-30 12:25
png file icon bnd_OK.png (938 bytes) 2015-01-30 12:25

- Relationships
related to 0025675closedbugmaster Open CASCADE Visualization - Fix problems and inefficiencies with frustum culling 
related to 0021911assignedkgv Open CASCADE Visualization - FitALL doesn't use all available space 

-  Notes
(0036882)
git (administrator)
2015-01-30 12:29

Branch CR25768 has been created by kgv.

SHA-1: 8ab40f1bac37f078c2f383d5d826c49b2c90c29f


Detailed log of new commits:

Author: kgv
Date: Fri Jan 30 12:29:33 2015 +0300

    0025768: Visualization, Graphic3d_Structure - do not use invalid bounding boxes of empty groups
    
    Prs3d_WFShape::Add() - do not create empty group
(0036951)
git (administrator)
2015-02-02 12:29

Branch CR25768 has been updated forcibly by kgv.

SHA-1: 411ce1d7e30a87743a4db741ee136bce8bd659a8
(0036952)
kgv (developer)
2015-02-02 12:29

Please test the patch in branch CR25768.
(0037088)
git (administrator)
2015-02-04 17:54

Branch CR25768 has been updated by apn.

SHA-1: fff8e4aa57d670b65e02e1e12f97a0a03f8ed944


Detailed log of new commits:

Author: apn
Date: Wed Feb 4 17:54:33 2015 +0300

    Added test case bugs/vis/bug25768

(0037089)
apn (administrator)
2015-02-04 18:08

Dear BugMaster,
Branch CR25768 from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms and tested in Release mode.
SHA-1: 411ce1d7e30a87743a4db741ee136bce8bd659a8

Number of compiler warnings:

occt component :
Linux: 18 (18 on master)
Windows: 0 (0 on master)

products component :
Linux: 11 (11 on master)
Windows: 1 (1 on master)

Regressions/Differences:
No regressions

Testing cases:
bugs vis bug25768 - OK
http://occt-tests/CR25768-master-occt/Debian60-64/bugs/vis/bug25768.html [^]
http://occt-tests/CR25768-master-occt/Windows-32-VC10/bugs/vis/bug25768.html [^]

Testing on Linux:
Total MEMORY difference: 370136408 / 369907280
Total CPU difference: 49164.18000000015 / 46828.580000000045

Testing on Windows:
Total MEMORY difference: 276532160 / 276837572
Total CPU difference: 34976.6875 / 39964.359375

There are differences in images found by testdiff:
bugs vis bug25178
http://occt-tests/CR25768-master-occt/Debian60-64/diff-Debian60-64.html [^]
http://occt-tests/CR25768-master-occt/Windows-32-VC10/diff-Windows-32-VC10.html [^]
(0037107)
kgv (developer)
2015-02-05 12:20

Dear bugmaster,

> There are differences in images found by testdiff:
> bugs vis bug25178
I have checked the test case - presentation and bounding box are correct.
The issue with z-clipping should be solved in scope of another issue #0025760.

Please switch to tested.
(0037487)
git (administrator)
2015-02-13 10:28

Branch CR25768 has been deleted by kgv.

SHA-1: fff8e4aa57d670b65e02e1e12f97a0a03f8ed944

- Related Changesets
occt: master 8d3aa19e
Timestamp: 2015-02-05 15:05:31
Author: kgv
Committer: bugmaster
Details ] Diff ]
0025768: Visualization, Graphic3d_Structure - do not use invalid bounding boxes of empty groups

Prs3d_WFShape::Add() - do not create empty group

Graphic3d_Structure::minMaxCoord() - do not use uninitialized bounding box

Added test case bugs/vis/bug25768
mod - src/Graphic3d/Graphic3d_Structure.cdl Diff ] File ]
mod - src/Graphic3d/Graphic3d_Structure.cxx Diff ] File ]
mod - src/Prs3d/Prs3d_WFShape.cxx Diff ] File ]
mod - src/StdPrs/StdPrs_DeflectionCurve.cxx Diff ] File ]
add - tests/bugs/vis/bug25768 Diff ] File ]

- Issue History
Date Modified Username Field Change
2015-01-30 12:25 kgv New Issue
2015-01-30 12:25 kgv Assigned To => kgv
2015-01-30 12:25 kgv File Added: bnd_KO.png
2015-01-30 12:25 kgv File Added: bnd_OK.png
2015-01-30 12:29 git Note Added: 0036882
2015-01-30 12:32 kgv Relationship added related to 0025675
2015-02-02 12:29 git Note Added: 0036951
2015-02-02 12:29 kgv Note Added: 0036952
2015-02-02 12:29 kgv Assigned To kgv => bugmaster
2015-02-02 12:29 kgv Status new => resolved
2015-02-02 12:30 kgv Status resolved => reviewed
2015-02-02 12:30 kgv Relationship added related to 0021911
2015-02-03 18:28 apn Assigned To bugmaster => apn
2015-02-04 17:54 git Note Added: 0037088
2015-02-04 18:08 apn Note Added: 0037089
2015-02-04 18:11 apn Test case number => bugs vis bug25768
2015-02-04 18:11 apn Assigned To apn => kgv
2015-02-04 18:11 apn Status reviewed => assigned
2015-02-05 12:20 kgv Note Added: 0037107
2015-02-05 12:20 kgv Assigned To kgv => bugmaster
2015-02-05 12:20 kgv Status assigned => feedback
2015-02-05 12:20 kgv Relationship added related to 0025760
2015-02-05 18:01 bugmaster Status feedback => tested
2015-02-06 15:38 bugmaster Changeset attached => occt master 8d3aa19e
2015-02-06 15:38 bugmaster Status tested => verified
2015-02-06 15:38 bugmaster Resolution open => fixed
2015-02-13 10:28 git Note Added: 0037487
2015-05-14 15:29 aiv Status verified => closed
2015-05-14 15:32 aiv Fixed in Version => 6.9.0


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker